/*   NOTE:  this part stack-checks
     Compile WITHOUT the "-s" opt
*/

#include <ctype.h>
#include "rma.common"

extern direct long nmbr_int;
extern direct int  is_extrn;
extern direct char **s_addrs, **d0053, d005f;
extern direct char d0063, *src_char, *d007c;

extern struct symblstr d0587;
extern struct optns d0791[], *optb_ptr;


do_long()             /* process a 32-bit operand */
{
   if ( getNmbr() == 0 ) {
      return 0;
   }
   l143e();
   l1389();
   return 1;
}

l2369()               /* process a 16-bit operand */
{
   if ( getNmbr() == 0 ) {
      return 0;
   }
   l143e();
   if ( optb_ptr >d0791 ) {
      l1389();
   }
   else {
      if ( (nmbr_int >= 65536) || (nmbr_int < -65536) ) {
         e_report( "value out of range" );
         return;
      }
   }
   d0063 &= 0x7f;
   return 1;
}

l2387()                 /* process an 8-bit operand */
{
   if ( getNmbr() == 0 ) {
      return 0;
   }
   d0063 |= 0x08;
   l143e();
   if ( optb_ptr > d0791 ) {
      l1389();
   }
   else {
      if ( (nmbr_int >= 256) || (nmbr_int < -256) ) {
         e_report( "value out of range" );
         return;
      }
   }
   d0063 &= 0x77;
   return 1;
}

getNmbr()
{
   skp_dlm();
   optb_ptr = d0791;
   if ( do_math(1) ) {
      switch ( *src_char ) {
         case ' ':
         case '\0':
         case ',':
         case ')':
         case ']':
            return 1;
      }
      e_report( "bad operator" );
   }
   return 0;
}

e_ilxtRf()
{
   is_extrn = nmbr_int = ilExtRef();
}

do_math(parm)
 int parm;
{
 struct optns  *var1;
 long   frstnum;
 int    var3,var4,var5;

   if ( l257e() == 0 ) {
      return 0;
   }
   while ( (var5 = mathtyp( *src_char )) >= parm ) {
      var4 = ( *(src_char++) );
      frstnum = nmbr_int;
      var1 = optb_ptr;
      var3 = is_extrn;
      if ( do_math( var5+1 ) == 0 ) {
         return 0;
      }
      is_extrn |= var3;
      switch ( var4 ) {
         case '+':
            nmbr_int = frstnum + nmbr_int;
            break;
         case '-':
            nmbr_int = frstnum - nmbr_int;
            while ( var1 < optb_ptr ) {
               (var1++)->optn ^= _HEXDIG;
            };
            break;
         case '*':
            if ( is_extrn ) {
               e_ilxtRf();
            }
            else {
               nmbr_int = frstnum * nmbr_int;
            }
            break;
         case '/':
            if ( is_extrn ) {
               e_ilxtRf();
            }
            else {
               if (nmbr_int == 0 ) {
                  e_report( "zero division" );
                  return;
               }
               nmbr_int = frstnum / nmbr_int;
            }
            break;
         case '&':
            if ( is_extrn ) {
               e_ilxtRf();
            }
            else {
               nmbr_int = frstnum & nmbr_int;
            }
            break;
         case '!':
            if ( is_extrn ) {
               e_ilxtRf();
            }
            else {
               nmbr_int = frstnum | nmbr_int;
            }
            break;
      }
   }
   return 1;
}

mathtyp( tst_char )
 char tst_char;
{
   switch ( tst_char ) {
      case '+':
      case '-':
         return 1;
      case '*':
      case '/':
         return 2;
      case '&':
      case '!':
         return 3;
   }
   return 0;      /* Default to "no match" */
}

l257e()
{
 struct optns *var1;
 unsigned var2, var3;

   is_extrn = 0;
   switch ( var3 = *(src_char++) ) {
      case '+':
         if ( l257e() ) {
            break;
         }
         return 0;
      case '-':
         var1 = optb_ptr;
         if ( l257e() ) {
            nmbr_int = -nmbr_int;
            while ( var1 < optb_ptr ) {
               (var1++)->optn ^= 0x40;
            }
            break;
         }
         return 0;
      case '^':
         if ( l257e() ) {
            if ( is_extrn ) {
               e_ilxtRf();
            }
            else {
               nmbr_int = ~nmbr_int;
            }
            break;
         }
         return 0;
      case '(':
         if ( do_math(1) ) {
            if ( *src_char == ')' ) {
               ++src_char;
               break;
            }
            else {
               e_report( "parenthesis missing" );
            }
         }
         return 0;
      case '*':
         if ( s_addrs == 0 ) {
            if ( d0053 == 0 ) {
               nmbr_int = e_report( "undefined org" );
               return;
            }
            else {
               nmbr_int = *d0053;
            }
         }
         else {
            nmbr_int = *s_addrs;
            optb_ptr->optn = d005f;
            (optb_ptr++)->optadr = d007c;
            is_extrn = 1;
         }
         break;
      case ''':
         if ( (nmbr_int = *(src_char++)) == '\0' ) {
            --src_char;
            return 0;
         }
         break;
      default:
         --src_char;
         if ( _getnum() ) {
            break;
         }
         if ( mov_lbl( &d0587 ) != 0 ) {
            l1f63();
            break;
         }
         else {
            nmbr_int = e_report( "bad operand" );
            return;
         }
   }
   return 1;      /* Success */
}

_getnum()
{
 unsigned base, _passes;
 char CTyp, Dgt;

   _passes = base = 0;
   CTyp = 8;
   switch ( Dgt = *src_char ) {
      case '%':
         Dgt = *(++src_char);
         base = 2;
         CTyp = 0x10;
         break;
      case '$':
         Dgt = *(++src_char);
         base = 16;
         CTyp = 0x20;
         break;
      default:
         if ( isdigit(Dgt) ) {
            base = 10;
         }
   }
   if ( base == 0 ) {
      return 0;
   }
   nmbr_int = 0;
   while (_chcodes[Dgt = (islower(Dgt) ? _toupper(Dgt) : Dgt)] & CTyp) {
      nmbr_int = (nmbr_int*base) + (Dgt - ((Dgt < 'A') ? '0' : 55));
      ++_passes;
      Dgt = *(++src_char);
   }
   return _passes;
}
